<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <span>
      <button v-on:click="$emit('up')">EasyCloud</button>
    </span>

    <span>
      &gt;
      <button v-on:click="schedule=null; edit=false">Schedules</button>
    </span>

    <span v-if="schedule && schedule.name">
      &gt;
      <button>{{schedule.name}}</button>
    </span>
          
    <v-divider/>
    
    <SchedulesList
      v-if = "(schedule==null || schedule.id==null) && !edit"
      v-on:selected="schedule=$event"
      v-on:edit="edit=true; schedule=$event"
    />

    <ScheduleViewer
      :scheduleId="schedule.id"
      v-if="schedule && schedule.id && !edit"
      v-on:edit="edit=true; schedule=$event"
      v-on:deleted="edit=false; schedule=null"
      v-on:clone="edit=true; schedule=$event; schedule.id=null; schedule.name='Copy of '+schedule.name; schedule.active=false; schedule.grants={owner:'me'}"
    />

    <ScheduleEditor
      :scheduleTemplate="schedule"
      v-if="schedule && edit"
      v-on:view="edit=false; schedule=$event"
    />

  </v-container>

</template>

<script>

import SchedulesList from './SchedulesList.vue';
import ScheduleViewer from './ScheduleViewer.vue';
import ScheduleEditor from './ScheduleEditor.vue';

export default {

  name: 'SchedulesMain',

  components: {
    ScheduleViewer,
    SchedulesList,
    ScheduleEditor
  },
  
  data: () => ({
    schedule: null,
    edit: false,
  })
  
};

</script>
